/*
 * ioctlcmd.h
 * 
 * Copyright (c) 2000, BindView Corporation.
 *
 * See LICENSE file.
 *
 */


#ifndef IOCTLCMD_H
#define IOCTLCMD_H


#define FILE_DEVICE_STRACE      0x0000A32F

/*
 * actual ioctls
 */
#define STRACE_hook      (unsigned long) CTL_CODE( FILE_DEVICE_STRACE, 0x00, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define STRACE_unhook    (unsigned long) CTL_CODE( FILE_DEVICE_STRACE, 0x01, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define STRACE_getdata   (unsigned long) CTL_CODE( FILE_DEVICE_STRACE, 0x02, METHOD_NEITHER,  FILE_ANY_ACCESS )
#define STRACE_getout    (unsigned long) CTL_CODE( FILE_DEVICE_STRACE, 0x03, METHOD_BUFFERED, FILE_ANY_ACCESS )

typedef struct {
    unsigned long seq;
    unsigned long pid;
    unsigned long tid;
    unsigned long call_num;
    unsigned long direction;
    unsigned long result;
    unsigned long args_size;
    unsigned long args[256];
} ENTRY, *PENTRY;

#define ENT_SIZE(ent)  (sizeof (*ent) - sizeof (ent->args) + ent->args_size)

#define MAX_DATA (0x10000 - 12)

#endif
